<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.*" %>

<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<jsp:useBean id="subscriptionBean"
             class="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBeanImpl"
             scope="session" />


<%
  /**
   * You can change these following variables to match the correct information, if necessary.
   */
  final int MAX_DISPLAY_CHARACTERS = 60;
  final int MAX_RECIPIENT_DISPLAY_CHARACTERS = 80;

  /**
   * this is the URL used to display the Hostname Search Window.
   * The directory structure should be based on the disk location, change if necessary.
   */
  final String NODE_POPUP_URL = request.getServletPath()+"/jsp/subscription/omw/OMSearchNode.jsp;jsessionid="+session.getId();
  final String NODE_GROUPS_POPUP_URL = request.getServletPath()+"/jsp/subscription/omw/OMSearchNodeGroups.jsp;jsessionid="+session.getId();
  final String OBJECT_POPUP_URL = request.getServletPath()+"/jsp/subscription/omw/OMSearchObject.jsp;jsessionid="+session.getId();
  final String POLICY_POPUP_URL = request.getServletPath()+"/jsp/subscription/omw/OMSearchPolicy.jsp;jsessionid="+session.getId();
  final String MGS_GROUP_POPUP_URL = request.getServletPath()+"/jsp/subscription/omw/OMSearchMsgGroup.jsp;jsessionid="+session.getId();
  
  final String NODE_PREDICATE_NAME = "NODE";
  final String NODE_GROUPS_PREDICATE_NAME = "NODE_GROUPS";
  final String NODE_GROUPS_TEXT_PREDICATE_NAME = "NODE_GROUPS_TEXT";
  final String APPLICATION_PREDICATE_NAME = "APPLICATION";
  final String MSG_GROUP_PREDICATE_NAME = "MESSAGE_GROUP";
  final String MSG_TEXT_PREDICATE_NAME = "MSG_TEXT";
  final String SEVERITY_PREDICATE_NAME = "SEVERITY";
  final String OBJECT_PREDICATE_NAME = "MSG_OBJECT";
  final String POLICY_PREDICATE_NAME = "MSG_SOURCE";
  String NODE_NAME = null;

%>


<subscription-panel xmlns:fi="http://apache.org/cocoon/forms/1.0#instance"
                    xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
					onload="setDefaultNodeSelection();onLoad();"
					onsubmit="selectTargetOptions(this);
							  return validateForm(this);"
					id="OMWSubscriptionForm">

<%
  // set up the map for storing the selected values for each predicate
  final HashMap<String, ArrayList<String>> selectedPredicateValuesMap = new HashMap<String, ArrayList<String>>();
  final HashMap<String, PredicateBean> predicateNameMap = new HashMap<String, PredicateBean>();
  final HashMap<String, String> predicateSummaryNamesMap = new HashMap<String, String>();

  final StringBuffer summaryName = new StringBuffer();
  // collect the selected predicate values, and pre-populated values
  Iterator<PredicateBeanImpl> iterator = subscriptionBean.getPredicateIterator();
  while(iterator.hasNext())
  {
     final PredicateBean predicate = iterator.next();
     ArrayList<String> selectedValues = new ArrayList<String>();
     selectedValues.addAll(predicate.getSelectedValues());

     selectedPredicateValuesMap.put(predicate.getPredicateName(), selectedValues);
     predicateNameMap.put(predicate.getPredicateName(), predicate);

     if(!predicate.getSelectedValues().isEmpty())
     {
       summaryName.delete(0, summaryName.length());
	   if(predicate.hasAnySelectedValue())
       {
         summaryName.append("ANY");
       }
	   else
	   {
         Iterator<String> valIter = predicate.getSelectedValues().iterator();
         while(valIter.hasNext())
         {
           summaryName.append(valIter.next());
           if(valIter.hasNext())
             summaryName.append(", ");
           if(summaryName.length() > MAX_DISPLAY_CHARACTERS)
           {
             summaryName.setLength(MAX_DISPLAY_CHARACTERS);
             break;
           }
         }
	   }
       predicateSummaryNamesMap.put(predicate.getPredicateName(), summaryName.toString());
    }
  }

  PredicateBean predicateNode = predicateNameMap.get(NODE_PREDICATE_NAME);
  NODE_NAME = predicateNode.getSelectedValue();
  PredicateBean predicateNodeGroups = predicateNameMap.get(NODE_GROUPS_PREDICATE_NAME);
  PredicateBean predicateNodeGroupsText = predicateNameMap.get(NODE_GROUPS_TEXT_PREDICATE_NAME);
  /**
   * This indicates which radio button is selected, Node by default
   */
  final boolean selectedNodePredicate = !predicateNode.getSelectedValues().isEmpty() || (predicateNodeGroups.getSelectedValues().isEmpty() && predicateNodeGroupsText.getSelectedValues().isEmpty());

  // Determine if its AlarmPoint 3.2 or Later.
  boolean isLaterVersion;
  try
  {
    Class.forName("com.invoqsystems.apex.model.event.EventTemplateImpl");
    isLaterVersion = true;
  }
  catch(Exception ex)
  {
    isLaterVersion = false;
  }

  boolean creatingSubscription;
  if(isLaterVersion)
  {
    final String subId = (String)request.getParameter("subscriptionId");
    final String subDomainId = (String)request.getParameter("subscriptionDomainId");
    creatingSubscription = (subId == null || "0".equals(subId)) || subDomainId == null;
  }
  else
  {
    final String queryString = (String)request.getQueryString();
    creatingSubscription = queryString == null;
  }


  /**
   * This tab count will contain the total number tabs that will be displayed.
   */
  // THe total number of tabs that will be displayed
  int tabCount = 5;
  if(creatingSubscription)
  {
    tabCount--;
	if(!isLaterVersion && !subscriptionBean.isSelfSubscription()) // Managed Version 3.1 & <
	{
	  tabCount--;
	}
  }
  if(subscriptionBean.isSelfSubscription())
  {
    tabCount--;
  }
  if(subscriptionBean.allOverridesSuppressed() && subscriptionBean.isTimeframeSuppressed())
  {
    tabCount--;
  }

  /**
   * This maps the tab position for each predicate.
   */
  final HashMap<String, String> predicateTabPositionMap = new HashMap<String, String>();
  predicateTabPositionMap.put(NODE_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(OBJECT_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(POLICY_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(NODE_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(NODE_GROUPS_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(NODE_GROUPS_TEXT_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(APPLICATION_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(MSG_GROUP_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(MSG_TEXT_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(SEVERITY_PREDICATE_NAME, "1");
%>

<style media="screen" type="text/css">
  span.forms-tab {    
    display: inline;
    position: relative;
    top: -1px;
    z-index: 1;
    overflow: hidden;
    font-weight: bold;    
    text-decoration: none;
    cursor: pointer;
    color: #555555;    
    background: transparent url(/static/images/layout/main-menu-bg-off.gif) no-repeat top left;
    padding: 6px 7px 1px 11px;
    border-right: 1px solid #666;
    border-bottom: 1px solid #666;
    border-top: none;
    border-left: none;    
    margin: 0;
  }

  span.forms-tab:hover {    
    background: transparent url(/static/images/layout/main-menu-bg-hover.gif) no-repeat top left;
  }

  span.forms-tab.forms-activeTab {
    display: inline;
    position: relative;
    top: 1px;
    z-index: 10;    
    overflow: hidden; 
    cursor: default;
    color: #000000;
    background: transparent url(/static/images/layout/main-menu-bg-selected.gif) no-repeat top left;
    padding: 7px 7px 1px 11px;
    border-bottom: none;
  }

  span.forms-tab.forms-activeTab:hover {
    background-color: #FFF;
    position: relative;
  }

  span.forms-tabContent {
    background-color: #FFF;
    border: 1px solid #666;
    /*padding: 3em;*/
    position: relative;
    z-index: 2;
  }

  #sandbag-01,
  #sandbag-02 {
    clear: left;
    float: left;
    padding: 0pt; /*border: 1px solid #0f0;*/
  }

  #sandbag-01 {
    height: 10px;
    width: 160px;
  }

  #sandbag-02 {
    height: 10px;
    width: 95px;
  }

  #refreshNodeButton, #refreshNodeGroupsButton {
    line-height: 18px;
    vertical-align: top;
  }

  #PREDICATE_VALUE_NODE, #PREDICATE_VALUE_NODE_GROUPS {
    width: 115px;
  }

  label#matching {
    font-weight: bold;
    width: 175px;
  }

  div.form-row label.summary {
    font-weight: bold;
    width: 85px;
    float: none;
    text-align: left;
    vertical-align: middle;
    padding: 0px 4px 0px 0px;
    margin-left: 0px;
  }

  span.summary-row {
    float: none;
    text-align: left;
    vertical-align: middle;
    padding: 0px 0px 0px 0px;
  }

  span.summary-row span.summary-item {
    float: none;
    padding: 0px 5px 0px 0px;
  }

  span.elipse {
    font-size: 11px;
    color: #0000CC;
    margin: 0px 0px 0px 5px;
    padding: 0;
    text-decoration: underline;
    background-color: transparent;
    border: none;
    cursor: pointer;
  }

  div.form-row ul#summary_list {
    margin-left: 100px;
    padding: 0px 0px 0px 0px;
  }

  div.form-row ul#summary_list li {
    display: list-item;
    padding: 0px 3px 0px 0px;
  }

  div.form-row ul#summary_list li.summary_AND {
    font-weight: bold;
    list-style: none;
    margin-left: 20px;
  }

  div.form-row ul#summary_list li.summary-item span.summary_text italic {
    font-style: italic;
  }

  .floatLeft {
    float: left;
  }
</style>

<script type="text/javascript" language="JavaScript">
  var old_forms_showTab;
  function onLoad()
  {
   old_forms_showTab = forms_showTab;
   forms_showTab = new_forms_showTab;
   var lastTab = document.OMWSubscriptionForm.currentTab.value;
   if(lastTab != null &amp;&amp; lastTab != "" &amp;&amp; lastTab != "null")
   forms_showTab("attributes", lastTab, 5, "");
  }

  function new_forms_showTab(tabgroup, idx, length, state)
  {
   document.OMWSubscriptionForm.currentTab.value = idx;
   old_forms_showTab(tabgroup, idx, length, state);
  }

  // form validation to ensure that all required predicates are supplied
  function validateForm(theForm)
  {
    if(selectedButtonId == "saveButton:input")
    {
      if (isBlank(theForm['name'].value))
      {
        alert('The Name ' + MSG_CustomRequiredField);
        theForm['name'].focus();
        selectedButtonId = "";
        return false;
      }

      if (theForm.elements['node.Choice:1'].checked == true)
      {
        theForm['PREDICATE_VALUE_<%= NODE_GROUPS_TEXT_PREDICATE_NAME%>'].value = "";
        removeAllOptions(theForm['PREDICATE_VALUE_<%= NODE_GROUPS_PREDICATE_NAME%>']);
        theForm['PREDICATE_VALUE_<%= NODE_GROUPS_PREDICATE_NAME%>'].disabled = false;
        theForm['PREDICATE_VALUE_<%= NODE_GROUPS_TEXT_PREDICATE_NAME%>'].disabled = false;
      }

      if (theForm.elements['node.Choice:2'].checked == true)
      {
        if (!isBlank(theForm['PREDICATE_VALUE_<%= NODE_GROUPS_TEXT_PREDICATE_NAME%>'].value) &amp;&amp;
            hasSelectedOptions(theForm['PREDICATE_VALUE_<%= NODE_GROUPS_PREDICATE_NAME%>']))
        {
          alert('The Node Groups predicate has values specified for both the text value and selection list.  Please correct.');
          selectedButtonId = "";
          return false;
        }
        removeAllOptions(theForm['PREDICATE_VALUE_<%= NODE_PREDICATE_NAME%>']);
        removeAllOptions(theForm['PREDICATE_VALUE_<%= OBJECT_PREDICATE_NAME%>']);
        removeAllOptions(theForm['PREDICATE_VALUE_<%= POLICY_PREDICATE_NAME%>']);
        removeAllOptions(theForm['PREDICATE_VALUE_<%= MSG_GROUP_PREDICATE_NAME%>']);
        theForm['PREDICATE_VALUE_<%= NODE_PREDICATE_NAME%>'].disabled = false;
      }

    }

    disableFormButtons(theForm);
    addFormField(theForm, 'hidden', selectedButtonId, requestedFormAction);
    return true;
  }

  function hasSelectedOptions(source)
  {
    var selectedOptions = 0;
    for (var i=(source.options.length-1); i>=0; i--)
    {
      if(source.options[i].selected)
        selectedOptions++;
    }
    return selectedOptions != 0;
  }

  // Adds the list of selected items selected in the child
  // window to its list. It is called by child window to do so.
  function updateCurrentNodes(source)
  {
    var target = document.getElementById('PREDICATE_VALUE_<%= NODE_PREDICATE_NAME%>');
    setSelectionOptions(source, target);
  }

  // Adds the list of selected items selected in the child
  // window to its list. It is called by child window to do so.
  function updateCurrentObjects(source)
  {
    var target = document.getElementById('PREDICATE_VALUE_<%= OBJECT_PREDICATE_NAME%>');
    setSelectionOptions(source, target);
  }

  // Adds the list of selected items selected in the child
  // window to its list. It is called by child window to do so.
  function updateCurrentPolicies(source)
  {
    var target = document.getElementById('PREDICATE_VALUE_<%= POLICY_PREDICATE_NAME%>');
    setSelectionOptions(source, target);
  }

  // Adds the list of selected items selected in the child
  // window to its list. It is called by child window to do so.
  function updateCurrentMsgGroups(source)
  {
    var target = document.getElementById('PREDICATE_VALUE_<%= MSG_GROUP_PREDICATE_NAME%>');
    setSelectionOptions(source, target);
  }

  // Adds the list of selected items selected in the child
  // window to its list. It is called by child window to do so.
  function updateCurrentNodeGroups(source)
  {
    var target = document.getElementById('PREDICATE_VALUE_<%= NODE_GROUPS_PREDICATE_NAME%>');
    setSelectionOptions(source, target);
  }

  function clearPoliciesAndObjects() {
    var objects = document.getElementById('PREDICATE_VALUE_<%= OBJECT_PREDICATE_NAME%>');
    removeAllOptions(objects);

    var policies = document.getElementById('PREDICATE_VALUE_<%= POLICY_PREDICATE_NAME%>');
    removeAllOptions(policies);
  }

  function setSelectionOptions(source, target)
  {
    // clear the left list
    removeAllOptions(target);
    // copy from source to left list
    copySelectedOptions(source, target);
  }

  function removeAllOptions(from)
  {
    for (var i=(from.options.length-1); i>=0; i--)
    {
      from.options[i] = null;
    }
    from.selectedIndex = -1;
  }

  function selectAllTargetOptions(theForm, name)
  {
    var target = theForm[name];
    // first select all of the options that match the regexp
    if(target != null) {
      selectAllOptions(target);
    }
  }

  function toggleDiv(id)
  {
    toggleDivNoImage(id);
  }

  function showDivIfNecessary(id)
  {
    var theStatus = document.getElementById(id).style.visibility;
    if (theStatus == 'hidden') {
      document.getElementById(id).style.visibility = 'visible';
      document.getElementById(id).style.display = 'block';
    }
  }

  function hideDivIfNecessary(id)
  {
    var theStatus = document.getElementById(id).style.visibility;
    if (theStatus == 'visible') {
      document.getElementById(id).style.visibility = 'hidden';
      document.getElementById(id).style.display = 'none';
    }
  }

  function popupSearch(href, name)
  {
    if (!window.focus) return true;
    windowPopup(href , name, '800','600','center','front');
    return false;
  }

  function popupSearchAddNode(href, name)
  {
    var theForm = document.forms['OMWSubscriptionForm'];
    var nodeSource = theForm['PREDICATE_VALUE_NODE'];
    if (theForm.elements['node.Choice:2'].checked != true	&amp;&amp; theForm.elements['policies.Choice:2'].checked != true	&amp;&amp; !nodeSource.options.length >0) {
      alert("You must select a Node.");
      return false;
    } else {
      var nodeName = "";
      for (var i=0; i &lt; nodeSource.options.length; i++) {
        if (i != 0)
          nodeName = nodeName + "," + nodeSource.options[i].value;
        else
          nodeName = nodeName + nodeSource.options[i].value;
      }
      if (!window.focus) return true;
      var currentNodes = true;
      if (theForm.elements['policies.Choice:2'].checked == true || (theForm.elements['node.Choice:2'].checked == true)) {
        currentNodes = false;
      }

      windowPopup(href + "?currentNodes="+currentNodes , name, '800','600','center','front');
      return false;
    }
  }

  function popupSearchMsgGroup(href, name)
  {
    var theForm = document.forms['OMWSubscriptionForm'];

    windowPopup(href, name, '800','600','center','front');
    return false;
  }

  // this is called by submitCloseChildSubmitParent
  function submitRefresh()
  {
    disableFormButtons(document.forms['OMWSubscriptionForm']);
    selectTargetOptions(document.forms['OMWSubscriptionForm']);
    addFormField(document.forms['OMWSubscriptionForm'], 'hidden', 'refreshButton', 'refreshButton');
    setTimeout("document.forms['OMWSubscriptionForm'].submit()", 500);
  }

  function sortListPredicates(theForm)
  {
    for (var i = 0; i &lt; theForm.elements.length; i++)
    {
      if (theForm.elements[i].type == "select-multiple")
      {
        if ((theForm.elements[i].name).substr(0, 16) == "PREDICATE_VALUE_")
        {
          sortSelect(theForm.elements[i]);
        }
      }
    }
  }

  function toggleNodeSelection(id)
  {
    var theForm = document.forms['OMWSubscriptionForm'];
    if(id == 'div-node') {
      theForm['node.Choice:1'].checked = true;
      hideDivIfNecessary('div-node-groups');
      theForm['PREDICATE_VALUE_<%= NODE_GROUPS_PREDICATE_NAME%>'].disabled = true;
      theForm['PREDICATE_VALUE_<%= NODE_GROUPS_TEXT_PREDICATE_NAME%>'].disabled = true;
      theForm['PREDICATE_VALUE_<%= NODE_PREDICATE_NAME%>'].disabled = false;
      theForm['PREDICATE_VALUE_<%= OBJECT_PREDICATE_NAME%>'].disabled = false;
      theForm['PREDICATE_VALUE_<%= POLICY_PREDICATE_NAME%>'].disabled = false;
      theForm['PREDICATE_VALUE_<%= MSG_GROUP_PREDICATE_NAME%>'].disabled = false;
      showDivIfNecessary(id);
    } else {
      theForm['node.Choice:2'].checked = true;
      hideDivIfNecessary('div-node');
      theForm['PREDICATE_VALUE_<%= NODE_PREDICATE_NAME%>'].disabled = true;
      theForm['PREDICATE_VALUE_<%= OBJECT_PREDICATE_NAME%>'].disabled = true;
      theForm['PREDICATE_VALUE_<%= POLICY_PREDICATE_NAME%>'].disabled = true;
      theForm['PREDICATE_VALUE_<%= NODE_GROUPS_PREDICATE_NAME%>'].disabled = false;
      theForm['PREDICATE_VALUE_<%= NODE_GROUPS_TEXT_PREDICATE_NAME%>'].disabled = false;
      theForm['PREDICATE_VALUE_<%= MSG_GROUP_PREDICATE_NAME%>'].disabled = false;
      showDivIfNecessary(id);
    }
  }

  function redirectForm()
  {

  }

  function selectTargetOptions(theForm)
  {
    selectAllTargetOptions(theForm, 'PREDICATE_VALUE_<%=NODE_PREDICATE_NAME%>');
    selectAllTargetOptions(theForm, 'PREDICATE_VALUE_<%=NODE_GROUPS_PREDICATE_NAME%>');
    selectAllTargetOptions(theForm, 'PREDICATE_VALUE_<%=OBJECT_PREDICATE_NAME%>');
    selectAllTargetOptions(theForm, 'PREDICATE_VALUE_<%=POLICY_PREDICATE_NAME%>');
    selectAllTargetOptions(theForm, 'PREDICATE_VALUE_<%=MSG_GROUP_PREDICATE_NAME%>');
  }

  // this will select node or node groups based on the supplied predicate data
  function setDefaultNodeSelection()
  {
<%
    if(selectedNodePredicate)
    {
      out.println("toggleNodeSelection('div-node');");
    }
    else
    {
      out.println("toggleNodeSelection('div-node-groups');");
    }
%>
  }

</script>

<input type="hidden" name="currentTab" value="<%=request.getParameter("currentTab")%>" />

<text-widget id="name">
  <value><%= subscriptionBean.getName() %></value>
</text-widget>

<group label="Attributes">

<tab-group id="attributes">

<%
  if(!creatingSubscription)
  {
%>

    <tab-content id="summary_tab" label="Summary">
        <div class="form-row">
          <label id="matching">Matching Any Event Where</label>
        </div>
        <div class="form-row">
        <ul id="summary_list">
<%
  iterator = subscriptionBean.getPredicateIterator();
  boolean firstNonEmptyPredicate = true;
  while(iterator.hasNext())
  {
     final PredicateBean predicate = iterator.next();
     if(!predicate.getSelectedValues().isEmpty())
     {
       String summary = predicateSummaryNamesMap.get(predicate.getPredicateName());
       String predPosition = predicateTabPositionMap.get(predicate.getPredicateName());
%>
		     <% if(!firstNonEmptyPredicate) { %>
              <li class="summary_AND">
              <span class="summary_text">AND</span>
              </li>
             <%}%>

          <li class="summary-item">
            <span class="predicate_data"><%=predicate.getPredicateName()%></span>
			<span class="summary_text italic"> <%=predicate.getSelectedOperatorType()%></span>
            <span class="predicate_data"> (<%=summary%></span>
            <% if(summary.length() == MAX_DISPLAY_CHARACTERS) { %>
            <span class="elipse" onclick="forms_showTab('attributes', <%=predPosition%>, <%=Integer.toString(tabCount)%>, '')" >...</span>
            <% } %>
            <span class="summary_text">)</span>
          </li>
<%
	   firstNonEmptyPredicate = false;
     }
  }
%>
        </ul>
        </div>

        <div class="form-row">
          <label class="summary">Available:</label>
         <span class="summary-row">
<%
          if(subscriptionBean.isOnSunday())
          {
            out.print("<span class=\"summary-item\">Sun</span>");
          }
          if(subscriptionBean.isOnMonday())
          {
            out.print("<span class=\"summary-item\">Mon</span>");
          }
          if(subscriptionBean.isOnTuesday())
          {
            out.print("<span class=\"summary-item\">Tue</span>");
          }
          if(subscriptionBean.isOnWednesday())
          {
            out.print("<span class=\"summary-item\">Wed</span>");
          }
          if(subscriptionBean.isOnThursday())
          {
            out.print("<span class=\"summary-item\">Thu</span>");
          }
          if(subscriptionBean.isOnFriday())
          {
            out.print("<span class=\"summary-item\">Fri</span>");
          }
          if(subscriptionBean.isOnSaturday())
          {
            out.print("<span class=\"summary-item\">Sat</span>");
          }
%>

          <span class="summary-item"><%=subscriptionBean.getStartTime()%></span>
          <span class="summary-item">-</span>
          <span class="summary-item"><%=subscriptionBean.getEndTime()%></span>
        </span>
        </div>
        <div class="form-row">
          <label class="summary">Using:</label>
         <span class="summary-row">
<%
          if(subscriptionBean.hasAllDeviceFilter())
          {
            out.print("<span class=\"summary-item\">All Devices</span>");
          }
          else
          {
            ArrayList<String> types = subscriptionBean.getDeviceTypeOverrides();
            for(String type : types)
            {
%>
            <span class="summary-item"><%=type.substring(NotificationAPI.DEVICE_FILTER_FIELD_PREFIX.length())%></span>
<%
            }
          }
%>
          </span>
        </div>
<%
  if(!subscriptionBean.isSelfSubscription())
  {
%>
        <div class="form-row">
          <label class="summary">Targeting:</label>
         <span class="summary-row">
<%
         int charactersDisplayed = 0;
         ArrayList<String> recipients = subscriptionBean.getRecipients();
         for(String recipient : recipients)
         {
%>
            <span class="summary-item"><%=recipient%></span>
<%
           charactersDisplayed += recipient.length();
           if(charactersDisplayed > MAX_RECIPIENT_DISPLAY_CHARACTERS)
           {
             out.print("<span class=\"summary-item\">...</span>");
             break;
           }
         }
%>
          </span>
        </div>

<%
  }
%>

    </tab-content>

<%
  }
%>

    <tab-content id="app_msg_sev_tab" label="HP Operations Manager Windows">
      <div class="form-row">
        <label/>
        <span>
          <input value="node" name="node.Choice" id="node.Choice:1" type="radio"
                 onclick="toggleNodeSelection('div-node');" />
        </span>
        <span for="node.Choice:1">Node</span>
        <span>
          <input value="nodegroups" name="node.Choice" id="node.Choice:2" type="radio"
                 onclick="toggleNodeSelection('div-node-groups');" />
        </span>
        <span for="node.Choice:2">Node Groups</span>
      </div>

      <multifield-grouping style="hidden" id="div-node" >
        <multifield-grouping>
  <%
          PredicateBean nodePredicate = predicateNameMap.get(NODE_PREDICATE_NAME);
          ArrayList<String> selectedNodes = selectedPredicateValuesMap.get(NODE_PREDICATE_NAME);
  %>
         <label class="widget" for="<%=nodePredicate.getPredicateValueWidgetId()%>">Node:</label>
          <span>
            <select size="5" multiple="0" id="<%=nodePredicate.getPredicateValueWidgetId()%>" name="<%=nodePredicate.getPredicateValueWidgetId()%>" >
  <%
            List<String> selectedPreds = nodePredicate.getSelectedValues();
            Collections.sort(selectedPreds, String.CASE_INSENSITIVE_ORDER);
            for (String name : selectedPreds)
            {
  %>
              <option value="<%= name%>" ><%= name%></option>
  <%
            }
  %>
             </select>
          </span>
          <action-button id="refreshNodeButton" label="Select Nodes" onclick="return popupSearch('<%= NODE_POPUP_URL %>', 'SearchNodeWindow');" />

          
        <div class="form-row">
          <label/>
          <span>
            <input value="nodes" name="policies.Choice" id="policies.Choice:1" type="radio" checked="yes"/>
          </span>
          <span for="policies.Choice:1">Select Policies/Objects from Current Nodes</span>
          <span>
            <input value="events" name="policies.Choice" id="policies.Choice:2" type="radio" />
          </span>
          <span for="policies.Choice:2">Select Policies/Objects from Messages</span>
        </div>
        </multifield-grouping>

      </multifield-grouping>

      <multifield-grouping style="hidden" id="div-node-groups" >
        <multifield-grouping>
<%
          PredicateBean nodeGroupsTextPredicate = predicateNameMap.get(NODE_GROUPS_TEXT_PREDICATE_NAME);
          String selectedNodeGroupsTextOperatorType = nodeGroupsTextPredicate.getSelectedOperatorType();
%>
          <pulldown-select id="<%=nodeGroupsTextPredicate.getOperatorWidgetId()%>"
                           label="Node Groups:" force-label="true"
                           <% if(selectedNodeGroupsTextOperatorType != null) { out.print("value=\""+ selectedNodeGroupsTextOperatorType +"\""); } %> >
<%
            for (String operatorType : subscriptionBean.getValidOperatorTypeValues())
            {
%>
              <selection-item value="<%=operatorType%>" label="<%=operatorType%>" />
<%
            }
%>
          </pulldown-select>
          <span>
            <input type="text" size="20"
                   id="<%=nodeGroupsTextPredicate.getPredicateValueWidgetId()%>"
                   name="<%=nodeGroupsTextPredicate.getPredicateValueWidgetId()%>"
                   value="<%=nodeGroupsTextPredicate.getSelectedValue()%>" />
          </span>
          <span class="italic">Empty Field = Any Value</span>
        </multifield-grouping>

        <div id="sandbag-01"/>
        <div class="form-row">
          <span>-- OR --</span>
        </div>

<%
        PredicateBean nodeGroupsPredicate = predicateNameMap.get(NODE_GROUPS_PREDICATE_NAME);
        ArrayList<String> selectedNodeGroups = selectedPredicateValuesMap.get(NODE_GROUPS_PREDICATE_NAME);
%>
        <div id="sandbag-02"/>
        <multifield-grouping>
          <span>
            <select size="5"
                    multiple="0"
                    id="<%=nodeGroupsPredicate.getPredicateValueWidgetId()%>"
                    name="<%=nodeGroupsPredicate.getPredicateValueWidgetId()%>" >
<%
            selectedPreds = nodeGroupsPredicate.getSelectedValues();
            Collections.sort(selectedPreds, String.CASE_INSENSITIVE_ORDER);
            for (String name : selectedPreds)
            {
%>
              <option value="<%= name%>" ><%= name%></option>
<%
            }
%>
             </select>
          </span>
          <action-button id="refreshNodeGroupsButton" label="Select Node Groups" onclick="return popupSearch('<%= NODE_GROUPS_POPUP_URL %>', 'SearchNodeGroupsWindow');" />
        </multifield-grouping>
        
        <div class="form-row">
          <label/>
          <span for="policies.Choice:1">Select Policies/Objects from Messages</span>
        </div>

      </multifield-grouping>

      <multifield-grouping id="div-policy" >
<%
        PredicateBean policyPredicate = predicateNameMap.get(POLICY_PREDICATE_NAME);
        ArrayList<String> selectedPolicy = selectedPredicateValuesMap.get(POLICY_PREDICATE_NAME);
%>
        <label class="widget" for="<%=policyPredicate.getPredicateValueWidgetId()%>">Policy:</label>
          <span>
            <select size="5" multiple="0" id="<%=policyPredicate.getPredicateValueWidgetId()%>" name="<%=policyPredicate.getPredicateValueWidgetId()%>" >
<%
            selectedPreds = policyPredicate.getSelectedValues();
            Collections.sort(selectedPreds, String.CASE_INSENSITIVE_ORDER);
            for (String name : selectedPreds)
            {
%>
              <option value="<%= name%>" ><%= name%></option>
<%
            }
%>
             </select>
          </span>
          <action-button id="refreshPolicyButton" label="Select Policies" onclick="return popupSearchAddNode('<%= POLICY_POPUP_URL %>', 'SearchPolicyWindow');" />

      </multifield-grouping>

      <multifield-grouping id="div-object" >

<%
        PredicateBean objectPredicate = predicateNameMap.get(OBJECT_PREDICATE_NAME);
        ArrayList<String> selectedOjbect = selectedPredicateValuesMap.get(OBJECT_PREDICATE_NAME);
%>
        <label class="widget" for="<%=objectPredicate.getPredicateValueWidgetId()%>">Objects:</label>
          <span>
            <select size="5" multiple="0" id="<%=objectPredicate.getPredicateValueWidgetId()%>" name="<%=objectPredicate.getPredicateValueWidgetId()%>" >
<%
            selectedPreds = objectPredicate.getSelectedValues();
            Collections.sort(selectedPreds, String.CASE_INSENSITIVE_ORDER);
            for (String name : selectedPreds)
            {
%>
              <option value="<%= name%>" ><%= name%></option>
<%
            }
%>
             </select>
          </span>
          <action-button id="refreshObjectButton" label="Select Objects" onclick="return popupSearchAddNode('<%= OBJECT_POPUP_URL %>', 'SearchObjectWindow');" />
      </multifield-grouping>

      <multifield-grouping>
<%
        PredicateBean msgTextPredicate = predicateNameMap.get(MSG_TEXT_PREDICATE_NAME);
        String selectedMsgTextOperatorType = msgTextPredicate.getSelectedOperatorType();
%>
        <pulldown-select id="<%=msgTextPredicate.getOperatorWidgetId()%>"
                         label="Message Text:" force-label="true"
                         <% if(selectedMsgTextOperatorType != null) { out.print("value=\""+ selectedMsgTextOperatorType +"\""); } %> >
<%
          for (String operatorType : subscriptionBean.getValidOperatorTypeValues())
          {
%>
            <selection-item value="<%=operatorType%>" label="<%=operatorType%>" />
<%
          }
%>
        </pulldown-select>
        <span id="<%=msgTextPredicate.getPredicateValueWidgetId()%>">
          <input type="text" size="20"
                 id="<%=msgTextPredicate.getPredicateValueWidgetId()%>"
                 name="<%=msgTextPredicate.getPredicateValueWidgetId()%>"
                 value="<%=msgTextPredicate.getSelectedValue()%>" />
        </span>
        <span class="italic">Empty Field = Any Value</span>
      </multifield-grouping>

      <multifield-grouping>
<%
      PredicateBean severityPredicate = predicateNameMap.get(SEVERITY_PREDICATE_NAME);
      ArrayList<String> selectedSeverities = selectedPredicateValuesMap.get(SEVERITY_PREDICATE_NAME);
%>
        <div class="form-row">
          <label class="widget" for="<%=severityPredicate.getPredicateValueWidgetId()%>">Severity:</label>
          <span  id="<%=severityPredicate.getPredicateValueWidgetId()%>">
            <select size="5" multiple="0" id="<%=severityPredicate.getPredicateValueWidgetId()%>" name="<%=severityPredicate.getPredicateValueWidgetId()%>" >
              <option value="<%=subscriptionBean.getAnyPredicateListValue() %>" <% if(selectedSeverities.contains(subscriptionBean.getAnyPredicateListValue()))out.print("selected=\"true\""); %> >-- ANY --</option>
  <%
              for (String name : severityPredicate.getPredicateValues())
              {
  %>
                <option value="<%= name%>" <% if(selectedSeverities.contains(name))out.print("selected=\"true\""); %> ><%= name%></option>
  <%
              }
  %>
             </select>
          </span>
        </div>
      </multifield-grouping>


      <multifield-grouping>
<%
        PredicateBean applicationPredicate = predicateNameMap.get(APPLICATION_PREDICATE_NAME);
        String selectedAppOperatorType = applicationPredicate.getSelectedOperatorType();
%>
        <pulldown-select id="<%=applicationPredicate.getOperatorWidgetId()%>"
                         label="Application:" force-label="true"
                         <% if(selectedAppOperatorType != null) { out.print("value=\""+ selectedAppOperatorType +"\""); } %> >
<%
          for (String operatorType : subscriptionBean.getValidOperatorTypeValues())
          {
%>
            <selection-item value="<%=operatorType%>" label="<%=operatorType%>" />
<%
          }
%>
        </pulldown-select>
        <span id="<%=applicationPredicate.getPredicateValueWidgetId()%>">
          <input type="text" size="20"
                 id="<%=applicationPredicate.getPredicateValueWidgetId()%>"
                 name="<%=applicationPredicate.getPredicateValueWidgetId()%>"
                 value="<%=applicationPredicate.getSelectedValue()%>" />
        </span>
        <span class="italic">Empty Field = Any Value</span>
      </multifield-grouping>

<multifield-grouping id="div-msgGroup" >

  <%
          PredicateBean msgGroupPredicate = predicateNameMap.get(MSG_GROUP_PREDICATE_NAME);
          ArrayList<String> selectedMsgGroup = selectedPredicateValuesMap.get(MSG_GROUP_PREDICATE_NAME);
  %>
          <label class="widget" for="<%=msgGroupPredicate.getPredicateValueWidgetId()%>">Message Groups</label>
            <span>
              <select size="5" multiple="0" id="<%=msgGroupPredicate.getPredicateValueWidgetId()%>" name="<%=msgGroupPredicate.getPredicateValueWidgetId()%>" >
  <%
              selectedPreds = msgGroupPredicate.getSelectedValues();
              Collections.sort(selectedPreds, String.CASE_INSENSITIVE_ORDER);
              for (String name : selectedPreds)
              {
  %>
                <option value="<%= name%>" ><%= name%></option>
  <%
              }
  %>
               </select>
            </span>
            <action-button id="refreshObjectButton" label="Select Message Groups" onclick="return popupSearchMsgGroup('<%= MGS_GROUP_POPUP_URL %>', 'SearchObjectWindow');" />
        </multifield-grouping>


    </tab-content>

<%
  if(!subscriptionBean.allOverridesSuppressed() || !subscriptionBean.isTimeframeSuppressed())
  {
%>
    <tab-content id="pref_tab" label="Preferences">

      <subscription-timeframe group-label="Timeframe" />
      <subscription-overrides group-label="Overrides" />

    </tab-content>

<%} %>

<%
  if(!subscriptionBean.isSelfSubscription())
  {
    if(isLaterVersion)
    {
%>
    <tab-content id="assigned_tab" label="Assign">

      <subscribed-recipients group-label="Recipients" />

    </tab-content>
<%
	}
	else if(!creatingSubscription)
	{
%>
    <tab-content id="assigned_tab" formsOnShow="redirectForm();">

      <tab-label><a href="SubscriptionMembers.do?subscriptionId=<%=request.getParameter("subscriptionId")%>">Assign</a></tab-label>

    </tab-content>
<%
	}
  }
%>

</tab-group>

</group>

</subscription-panel>
